// This script is called on load of the widget

var textLines = new Array();

var grabPos = 0;

function grabWindow(isRight)
{
	grabPos = system.event.x;
}

function stretchWindow(isRight)
{
	var newLeft = mainWindow.hOffset;
	var newWidth = mainWindow.width;

	if (isRight)
	{
		newWidth = mainWindow.width + (system.event.x - grabPos);
		if (newWidth < 200)
			newWidth = 200;
	}
	else
	{
		newWidth = mainWindow.width - (system.event.x - grabPos);
		if (newWidth < 200)
			newWidth = 200;
		newLeft = mainWindow.hOffset - (newWidth - mainWindow.width);
	}

	suppressUpdates();

	preferences.mainWidth.value = newWidth;
	savePreferences();

	mainWindow.hOffset = newLeft;
	mainWindow.width = newWidth;

	updateBackground();

	resumeUpdates();
}

function updateWindow()
{
	suppressUpdates();

	mainWindow.width = preferences.mainWidth.value;

	updateText();
	updateBackground();

	resumeUpdates();
}

function updateText()
{
	var text = preferences.mannaText.value;

	text = text.replace(new RegExp("&(lt);", "ig"), "<");
	text = text.replace(new RegExp("&(gt);", "ig"), ">");
	text = text.replace(new RegExp("&(quot);", "ig"), "\"");
	text = text.replace(new RegExp("&(nbsp);", "ig"), " ");
	text = text.replace(new RegExp("&(#8212);", "g"), "-");
	text = text.replace(new RegExp("&(amp);", "ig"), "&");

	if (preferences.suppressUnknown.value == 1)
	{
		text = text.replace(new RegExp("&(#\\d+);", "g"), " ");
		text = text.replace(new RegExp("&(\\w+);", "g"), " ");
	}

	text = text.replace(new RegExp("<a href=.*</a>", "ig"), "");
	text = text.replace(new RegExp("<[^>]+>", "g"), "");
	text = text.replace(new RegExp("(^\\s+)", "g"), " ");
	text = text.replace(new RegExp("(^\\s+)|(\\s+$)", "g"), "");

	for (var y = 0; y < textLines.length; y ++)
	{
		textLines[y].data = "";
		updateTextAttr(textLines[y], 1.0);
	}
	updateTextAttr(textSizer, 1.0);
	var y = 0;
	var words = text.split(" ");
	for (var w = 0; w < words.length; w ++)
	{
		textSizer.data = " " + words[w];

		if (y == 0 || textLines[y-1] == null
			|| textLines[y-1].hOffset + textLines[y-1].width + textSizer.width + 16 > mainWindow.width)
		{
			textLines[y] = new Text();
			textLines[y].window = mainWindow;
			textLines[y].hOffset = 20;
			textLines[y].vOffset = (textSizer.height * (y+1)) + 16;
			textLines[y].data = words[w];
			updateTextAttr(textLines[y], 1.0);
			y ++;
		}
		else
		{
			textLines[y-1].data += textSizer.data;
		}
	}
	if (textLines[y-1].hOffset + textLines[y-1].width + 48 > mainWindow.width)
		y ++;

	var newHeight = (textSizer.height * y) + 40;
	if (preferences.expandUp.value == 1 && mainWindow.height > 0)
		mainWindow.vOffset -= (newHeight - mainWindow.height);
	mainWindow.height = newHeight;

	if (mainWindow.hOffset < 0)
		mainWindow.hOffset = 0;
	if (mainWindow.hOffset >= screen.width * 2)
		mainWindow.hOffset = screen.width - 16;

	if (mainWindow.vOffset < 0)
		mainWindow.vOffset = 0;
	if (mainWindow.vOffset >= screen.height)
		mainWindow.vOffset = screen.height - 16;

	textSizer.data = "";
}

function updateTextAttr(textObj, scale)
{
	textObj.color = preferences.textColor.value;
	textObj.opacity = preferences.textOpacity.value;
	textObj.font = preferences.textFont.value;
	textObj.size = preferences.fontSize.value * scale;
	textObj.tooltip = preferences.mannaTitle.value;
}

function updateBackground()
{
	var mainWidth = mainWindow.width;
	var mainHeight = mainWindow.height;

	updateBgImage(background, "background.png", true, 16, 16, mainWidth-32, mainHeight-32);
	updateBgImage(frameTopLeft, "frame-top-left.png", true, 0, 0, 16, 16);
	updateBgImage(frameTop, "frame-top.png", true, 16, 0, mainWidth-32, 16);
	updateBgImage(frameTopRight, "frame-top-right.png", true, mainWidth-16, 0, 16, 16);
	updateBgImage(frameLeft, "frame-left.png", true, 0, 16, 16, mainHeight-32);
	updateBgImage(frameRight, "frame-right.png", true, mainWidth-16, 16, 16, mainHeight-32);
	updateBgImage(frameBottomLeft, "frame-bottom-left.png", true, 0, mainHeight-16, 16, 16);
	updateBgImage(frameBottom, "frame-bottom.png", true, 16, mainHeight-16, mainWidth-32, 16);
	updateBgImage(frameBottomRight, "frame-bottom-right.png", true, mainWidth-16, mainHeight-16, 16, 16);
	updateBgImage(bookLink, "book-link.png", false, mainWidth-32, mainHeight-32, 16, 16);
}

function updateBgImage(image, imageFile, isback, left, top, width, height)
{
	image.hOffset = left;
	image.vOffset = top;
	image.width = width;
	image.height = height;
	image.src = "Resources/" + preferences.skin.value + "/" + imageFile;

	if (isback)
	{
		image.colorize = preferences.bgColor.value;
		image.opacity = preferences.bgOpacity.value;
	}
}

function getManna()
{
	var bible = preferences.prefBible.value.split("|");

	var url = new URL;
	url.location = bible[0];

	url.fetchAsync(getMannaDone);
}

function getMannaDone(url)
{
	if (url.response != 200)
	{
		preferences.mannaTime.value = (new Date()).getTime();
		savePreferences();

		alert("Failed to download latest Manna (http error " + url.response + ")\n\n"
			+ "If your network is not always online, try setting the update time to 'Manual Only'");
		return;
	}

	var bible = preferences.prefBible.value.split("|");
	var manna = url.result;
	var title = "";
	var text = "";

	manna = manna.replace(new RegExp("\\s", "g"), " ");
	if (bible.length > 1 && bible[1] != "")
		manna = manna.replace(new RegExp(".*(<title>[^<]*" + bible[1] + "[^<]*</title>)", "i"), "$1");

	manna = manna.replace(new RegExp("</item>.*", "i"), "");
	manna = manna.replace(new RegExp(".*<item[^<]*>", "i"), "");

	title = manna.replace(new RegExp("</title>.*", "i"), "");
	title = title.replace(new RegExp(".*<title[^<]*>", "i"), "");

	text = manna.replace(new RegExp("</description>.*", "i"), "");
	text = text.replace(new RegExp(".*<description[^<]*>", "i"), "");

	link = manna.replace(new RegExp("</link>.*", "i"), "");
	link = link.replace(new RegExp(".*<link[^<]*>", "i"), "");

	preferences.mannaTitle.value = title;
	preferences.mannaText.value = text;
	preferences.mannaLink.value = link;
	preferences.mannaBible.value = preferences.prefBible.value;
	preferences.mannaTime.value = (new Date()).getTime();
	savePreferences();

	updateWindow();
}

function checkManna()
{
	if (preferences.checkHour.value == "manual")
		return;

	if (preferences.mannaTime.value == "")
	{
		getManna();
		return;
	}
	var oneHour = 3600000;
	var lastMannaTime = new Date(parseInt(preferences.mannaTime.value));
	var waitHours = (parseInt(preferences.checkHour.value) + 23 - lastMannaTime.getHours()) % 24 + 1;
	var expireTime = new Date(lastMannaTime.getTime() + (waitHours * oneHour));
	expireTime.setMinutes(0);
	expireTime.setSeconds(0);

	if (new Date() >= expireTime)
		getManna();
}

updateWindow();
mainWindow.visible = true;

